/*
*  barremdlgs.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef barremdlgsH
#define barremdlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <CheckLst.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------

bool __fastcall ManageBarredRemailers(TForm *Owner);

class TBarRemDlg : public TForm
{
__published:	// IDE-managed Components
        TCheckListBox *RemList;
        TButton *OkBtn;
        TButton *CancelBtn;
        TLabel *Label1;
        TPopupMenu *PopupMenu;
        TMenuItem *Resizedialog1;
        TMenuItem *Locksize1;
        TButton *HelpBtn;
        TRadioButton *ChainsBox;
        TRadioButton *LastBox;
        TRadioButton *DirectBox;
        TTimer *Timer1;
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall Resizedialog1Click(TObject *Sender);
        void __fastcall Locksize1Click(TObject *Sender);
        void __fastcall PopupMenuPopup(TObject *Sender);
        void __fastcall HelpBtnClick(TObject *Sender);
        void __fastcall ChainsBoxClick(TObject *Sender);
        void __fastcall LastBoxClick(TObject *Sender);
        void __fastcall DirectBoxClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        int mode;
        TStringList *bars, *pubring, *direct, *last, *rems;
        AnsiString orgwin, orgbars, orglast,orgdirect;
        __fastcall TBarRemDlg(TComponent* Owner);
        __fastcall virtual ~TBarRemDlg();
        //void __fastcall LoadRemailers();
        void __fastcall GatherBarred();
};

const int brChains = 1;
const int brLast = 2;
const int brDirect = 3;
//---------------------------------------------------------------------------
//extern PACKAGE TBarRemDlg *BarRemDlg;
//---------------------------------------------------------------------------
#endif
