/*
*  composewins.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
*
*  If you modify QuickSilver Lite, or any covered work, by linking or
*  combining it with CodeGear VCL (or a modified version of that library),
*  containing parts covered by the terms of CodeGear's license, the licensors
*  of QuickSilver Lite grant you additional permission to convey the
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#ifndef composewinsH
#define composewinsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "utility.h"
#include "msgmans.h"
#include <ImgList.hpp>
#include <Dialogs.hpp>
#include "global.h"
#include "optionsdlgs.h"
#include <Graphics.hpp>
//#include "checker.h"
class TComposeWin;
//---------------------------------------------------------------------------

TComposeWin* __fastcall NewComposeWindow(TForm *Owner, TStrings *message = NULL, const AnsiString &msgkey = "");
TComposeWin* __fastcall NewComposeWindowEx(TForm *Owner);

class TComposeWin : public TForm
{
__published:	// IDE-managed Components
		TMainMenu *MainMenu;
		TMenuItem *FileMenu;
		TMenuItem *FileExit;
		TMenuItem *EditMenu;
		TMenuItem *ToolsMenu;
		TMenuItem *HelpMenu;
		TMenuItem *About1;
		TMenuItem *FileSend;
		TMenuItem *FileNew;
		TMenuItem *EditUndo;
		TMenuItem *EditCut;
		TMenuItem *EditCopy;
		TMenuItem *EditPaste;
		TMenuItem *N2;
		TMenuItem *EditDelete;
		TMenuItem *EditSelectAll;
        TPopupMenu *PopupMenu;
        TMenuItem *PopupUndo;
        TMenuItem *PopupCut;
        TMenuItem *PopupCopy;
        TMenuItem *PopupPaste;
        TMenuItem *PopupDelete;
        TMenuItem *PopupSelectAll;
        TMenuItem *ToolsUpdateStats;
        TMenuItem *FileSaveasnewmessage;
        TTimer *Timer1;
        TMenuItem *ToolsBarredremailers;
        TMenuItem *ToolsUpdateAllpingerstxt;
        TMenuItem *ViewMenu;
        TMenuItem *Viewmixcfg;
	TMenuItem *Viewerrlog;
        TMenuItem *N5;
	TMenuItem *Viewmlisttxt;
	TMenuItem *Viewpubringmix;
		TMenuItem *Viewrlisttxt;
        TMenuItem *Viewpubringasc;
        TMenuItem *N6;
	TMenuItem *Viewallpingerstxt;
        TMenuItem *N7;
        TMenuItem *ToolsEmailheaders;
        TMenuItem *ClipboardMenu;
        TMenuItem *FollowUp1;
        TMenuItem *Reply1;
        TPanel *ToolBar;
        TSpeedButton *SendBtn;
        TSpeedButton *CutBtn;
        TSpeedButton *CopyBtn;
        TSpeedButton *PasteBtn;
        TSpeedButton *EncryptBtn;
		TBevel *Bevel1;
        TBevel *Bevel2;
        TBevel *Bevel3;
		TStatusBar *StatusBar;
        TMenuItem *N8;
        TMenuItem *EditWordWrap;
        TMenuItem *N9;
        TMenuItem *ToolsOptions;
        TMenuItem *N1;
        TMenuItem *ViewSMTPlog;
        TMenuItem *FileOpen;
        TMenuItem *FileSave;
        TMenuItem *FileSaveAsTemplate;
        TMenuItem *FilePreview;
        TMenuItem *ToolsExpertmode;
        TMenuItem *N12;
        TSpeedButton *NewBtn;
        TBevel *Bevel4;
        TSpeedButton *OpenBtn;
        TSpeedButton *RemailerBtn;
		TImageList *ImageList1;
        TBevel *Bevel5;
        TMenuItem *N13;
        TMenuItem *N4;
        TMenuItem *ToolsAttachfile;
        TMenuItem *ToolsDecoder;
        TMenuItem *Topics1;
        TMenuItem *ToolsRemailercaps;
		TMenuItem *FileNewwindow;
        TMenuItem *N14;
        TMenuItem *ToolsProxyMenu;
        TMenuItem *HTTP1;
        TMenuItem *SMTP1;
        TMenuItem *FileOpenTemplate;
        TMenuItem *FileOpenQSdir;
        TMenuItem *MailboxMenu;
        TMenuItem *Mailboxoutbox;
        TMenuItem *N15;
        TSpeedButton *OutboxBtn;
		TBevel *Bevel6;
        TMenuItem *ToolsOutbox;
        TMenuItem *ToolsSMTPhosts;
        TMenuItem *FilePackdatabase;
        TMenuItem *N16;
        TMenuItem *N10;
        TMenuItem *FileSecuremode;
        TSpeedButton *SignBtn;
        TComboBox *ProxyBox;
        TLabel *Label1;
        TMenuItem *ToolsProxies;
        TMenuItem *FileSavedatabase;
        TMenuItem *N11;
        TMenuItem *N3;
        TSpeedButton *QueueBtn;
        TBevel *Bevel7;
		TMenuItem *FileSendqueuedmail;
        TMenuItem *FileQueuemessage;
        TMenuItem *N17;
        TMenuItem *Messagequeue;
        TMenuItem *Problemqueue;
        TMenuItem *N18;
        TMenuItem *FileSaveas;
        TMenuItem *FileOpenDraft;
        TMenuItem *N19;
        TSpeedButton *DraftBtn;
        TMenuItem *N20;
        TMenuItem *ToolsAddressbook;
        TMenuItem *ToolsSelectrecipients;
        TSpeedButton *AddressBtn;
		TBevel *Bevel8;
        TMenuItem *N21;
        TMenuItem *PopupSave;
        TMenuItem *PopupSaveas;
        TMenuItem *PopupSaveasNewMessage;
        TMenuItem *PopupSaveasTemplate;
		TMenuItem *HelpReleasenotes;
        TMenuItem *N22;
		TMenuItem *FileOpenQSdatadir;
	TMenuItem *Knownproblems1;
	TMenuItem *N23;
	TMenuItem *Updatepage1;
	TMenuItem *Viewmixtls;
	TMenuItem *HelpHistory;
	TMenuItem *N24;
	TMenuItem *PopupDoPGPoperationnow;
	TMenuItem *PopupDofinalformatnow;
	TMenuItem *ToolsPGPkeyring;
	TMenuItem *Commandprompt1;
	TMenuItem *N25;
	TMainMenu *QS2MainMenu;
	TMenuItem *MenuItem1;
	TMenuItem *MenuItem2;
	TMenuItem *MenuItem3;
	TMenuItem *MenuItem4;
	TMenuItem *FilePreviewsend;
	TMenuItem *MenuItem6;
	TMenuItem *MenuItem7;
	TMenuItem *MenuItem8;
	TMenuItem *MenuItem9;
	TMenuItem *MenuItem10;
	TMenuItem *MenuItem11;
	TMenuItem *MenuItem12;
	TMenuItem *MenuItem13;
	TMenuItem *MenuItem14;
	TMenuItem *MenuItem15;
	TMenuItem *MenuItem16;
	TMenuItem *MenuItem17;
	TMenuItem *MenuItem18;
	TMenuItem *MenuItem19;
	TMenuItem *MenuItem20;
	TMenuItem *MenuItem21;
	TMenuItem *MenuItem22;
	TMenuItem *MenuItem23;
	TMenuItem *MenuItem24;
	TMenuItem *MenuItem25;
	TMenuItem *MenuItem26;
	TMenuItem *MenuItem27;
	TMenuItem *MenuItem28;
	TMenuItem *MenuItem29;
	TMenuItem *MenuItem30;
	TMenuItem *MenuItem31;
	TMenuItem *MenuItem32;
	TMenuItem *MenuItem33;
	TMenuItem *MenuItem34;
	TMenuItem *MenuItem36;
	TMenuItem *MenuItem37;
	TMenuItem *MenuItem38;
	TMenuItem *MenuItem39;
	TMenuItem *MenuItem40;
	TMenuItem *MenuItem41;
	TMenuItem *MenuItem42;
	TMenuItem *MenuItem43;
	TMenuItem *MenuItem44;
	TMenuItem *MenuItem45;
	TMenuItem *MenuItem46;
	TMenuItem *MenuItem47;
	TMenuItem *MenuItem48;
	TMenuItem *MenuItem49;
	TMenuItem *MenuItem50;
	TMenuItem *MenuItem51;
	TMenuItem *MenuItem52;
	TMenuItem *MenuItem53;
	TMenuItem *MenuItem54;
	TMenuItem *MenuItem55;
	TMenuItem *MenuItem56;
	TMenuItem *MenuItem57;
	TMenuItem *MenuItem58;
	TMenuItem *MenuItem59;
	TMenuItem *MenuItem60;
	TMenuItem *MenuItem61;
	TMenuItem *MenuItem62;
	TMenuItem *MenuItem63;
	TMenuItem *MenuItem64;
	TMenuItem *MenuItem65;
	TMenuItem *MenuItem66;
	TMenuItem *MenuItem67;
	TMenuItem *MenuItem68;
	TMenuItem *MenuItem69;
	TMenuItem *MenuItem70;
	TMenuItem *MenuItem71;
	TMenuItem *MenuItem72;
	TMenuItem *MenuItem73;
	TMenuItem *MenuItem74;
	TMenuItem *MenuItem75;
	TMenuItem *MenuItem76;
	TMenuItem *MenuItem77;
	TMenuItem *MenuItem78;
	TMenuItem *MenuItem79;
	TMenuItem *MenuItem80;
	TMenuItem *MenuItem81;
	TMenuItem *MenuItem82;
	TMenuItem *MenuItem83;
	TMenuItem *MenuItem84;
	TMenuItem *MenuItem85;
	TMenuItem *MenuItem86;
	TMenuItem *MenuItem87;
	TMenuItem *MenuItem88;
	TMenuItem *MenuItem89;
	TMenuItem *MenuItem90;
	TMenuItem *MenuItem91;
	TMenuItem *MenuItem92;
	TMenuItem *MenuItem93;
	TMenuItem *MenuItem94;
	TMenuItem *MenuItem95;
	TMenuItem *POP3hosts1;
	TSpeedButton *PrintBtn;
	TBevel *Bevel9;
	TMenuItem *N26;
	TMenuItem *Print1;
	TMenuItem *message1;
	TMenuItem *USENETarticle1;
	TMenuItem *N27;
	TMenuItem *Find1;
	TFindDialog *FindDialog;
	TSpeedButton *DeleteBtn;
	TBevel *Bevel10;
	TMenuItem *N28;
	TMenuItem *FileDelete;
	TMenuItem *Pastequoted1;
	TMenuItem *ToolsAltAAMItem;
	TMenuItem *ToolsAAMItem;
	TBevel *Bevel11;
	TMenuItem *N29;
	TMenuItem *FileUninstallprogram;
	TSpeedButton *MailQueueBtn;
	TSpeedButton *ProbQueueBtn;
	TBevel *Bevel12;
	TSpeedButton *SaveBtn;
	TSpeedButton *SaveMenuBtn;
	TBevel *Bevel13;
	TPopupMenu *PopupSaveMenu;
	TMenuItem *as1;
	TMenuItem *asTemplate1;
	TMenuItem *as2;
	TMenuItem *PopupSaveItem;
	TRichEdit *Editor;
	TMenuItem *N30;
	TMenuItem *Viewssllogtxt;
	TMenuItem *N40961024keys1;
	TMenuItem *N31;
	TMenuItem *PopupSaveDatabaseItem;
        void __fastcall FileNewClick(TObject *Sender);
		void __fastcall FileExitClick(TObject *Sender);
        void __fastcall EditMenuClick(TObject *Sender);
        void __fastcall EditItemClick(TObject *Sender);
        void __fastcall PopupMenuPopup(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall ToolsUpdateStatsClick(TObject *Sender);
        void __fastcall ToolsBarredremailersClick(TObject *Sender);
		void __fastcall FileSendClick(TObject *Sender);
        void __fastcall ToolsUpdateAllpingerstxtClick(TObject *Sender);
        void __fastcall EditorMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall ViewmixcfgClick(TObject *Sender);
        void __fastcall ViewMenuClick(TObject *Sender);
        void __fastcall UpdateBtnClick(TObject *Sender);
        void __fastcall EditorSelectionChange(TObject *Sender);
        void __fastcall EditBtnClick(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall FileSaveasnewmessageClick(TObject *Sender);
        void __fastcall ToolsOptionsClick(TObject *Sender);
		void __fastcall ToolsEmailheadersClick(TObject *Sender);
        void __fastcall ViewSMTPlogClick(TObject *Sender);
        void __fastcall FormPaint(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall FileOpenTemplateClick(TObject *Sender);
		void __fastcall FileSaveAsTemplateClick(TObject *Sender);
        void __fastcall FilePreviewClick(TObject *Sender);
        void __fastcall FileMenuClick(TObject *Sender);
        void __fastcall FileSaveClick(TObject *Sender);
        void __fastcall FollowUp1Click(TObject *Sender);
        void __fastcall Reply1Click(TObject *Sender);
        void __fastcall ToolsMenuClick(TObject *Sender);
        void __fastcall ToolsExpertmodeClick(TObject *Sender);
        void __fastcall ToolsAttachfileClick(TObject *Sender);
        void __fastcall ToolsDecoderClick(TObject *Sender);
        void __fastcall Topics1Click(TObject *Sender);
        void __fastcall ToolsRemailercapsClick(TObject *Sender);
		void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall FileNewwindowClick(TObject *Sender);
        void __fastcall HTTP1Click(TObject *Sender);
		void __fastcall SMTP1Click(TObject *Sender);
        void __fastcall FileOpenQSdirClick(TObject *Sender);
        void __fastcall MailboxItemClick(TObject *Sender);
        void __fastcall MailboxMenuClick(TObject *Sender);
        void __fastcall OutboxBtnClick(TObject *Sender);
		void __fastcall ToolsSMTPhostsClick(TObject *Sender);
        void __fastcall FilePackdatabaseClick(TObject *Sender);
        void __fastcall FileSecuremodeClick(TObject *Sender);
        void __fastcall ProxyBoxChange(TObject *Sender);
        void __fastcall ToolsProxiesClick(TObject *Sender);
        void __fastcall FileSavedatabaseItemClick(TObject *Sender);
        void __fastcall FileSendqueuedmailClick(TObject *Sender);
        void __fastcall FileQueuemessageClick(TObject *Sender);
        void __fastcall MessagequeueClick(TObject *Sender);
        void __fastcall ProblemqueueClick(TObject *Sender);
        void __fastcall FileSaveasClick(TObject *Sender);
        void __fastcall FileOpenDraftClick(TObject *Sender);
		void __fastcall ToolsAddressbookClick(TObject *Sender);
        void __fastcall ToolsSelectrecipientsClick(TObject *Sender);
        void __fastcall HelpReleasenotesClick(TObject *Sender);
        void __fastcall HelpMenuClick(TObject *Sender);
        void __fastcall FileOpenQSdatadirClick(TObject *Sender);
        void __fastcall FileOpenClick(TObject *Sender);
		void __fastcall ProxyBoxSelect(TObject *Sender);
		void __fastcall ProxyBoxDropDown(TObject *Sender);
		void __fastcall ProxyBoxCloseUp(TObject *Sender);
		void __fastcall Knownproblems1Click(TObject *Sender);
		void __fastcall Updatepage1Click(TObject *Sender);
		void __fastcall PGPBtnClick(TObject *Sender);
		void __fastcall ViewmixtlsClick(TObject *Sender);
		void __fastcall HelpHistoryClick(TObject *Sender);
		void __fastcall ToolsPGPkeyringClick(TObject *Sender);
		void __fastcall Commandprompt1Click(TObject *Sender);
		void __fastcall FileSaveasnewUSENETarticle1Click(TObject *Sender);
		void __fastcall Print1Click(TObject *Sender);
		void __fastcall FindDialogFind(TObject *Sender);
		void __fastcall Find1Click(TObject *Sender);
		void __fastcall FileDeleteClick(TObject *Sender);
		void __fastcall Pastequoted1Click(TObject *Sender);
		void __fastcall ToolsAltAAMItemClick(TObject *Sender);
		void __fastcall FileUninstallprogramClick(TObject *Sender);
		void __fastcall MailQueueBtnClick(TObject *Sender);
		void __fastcall ProbQueueBtnClick(TObject *Sender);
		void __fastcall TapQueues();
	void __fastcall MailQueueBtnMouseEnter(TObject *Sender);
	void __fastcall ProbQueueBtnMouseEnter(TObject *Sender);
	void __fastcall SaveMenuBtnClick(TObject *Sender);
	void __fastcall PopupSaveMenuPopup(TObject *Sender);
	void __fastcall ViewssllogtxtClick(TObject *Sender);
	void __fastcall N40961024keys1Click(TObject *Sender);
private:	// User declarations
		void __fastcall CreateParams( TCreateParams &Params );
public:		// User declarations
		WORD LastKey;
		int LastLine, LastStart; //, closestatus;
		TStringList *original;
		//TASpellChecker *checker;
		//TSaveDialog *SaveDialog;
		bool expertmode, orgencryptdown, orgsigndown, openmessage, preview, noshow,
		   hardclose;
		AnsiString orgcap, orgwin, msgtype, msgname, defsmtp, inreplyto,
		   mailbox, msgkey;
		__fastcall virtual TComposeWin(TComponent* Owner);
		__fastcall virtual TComposeWin(TComponent* Owner, TStrings *message);
		__fastcall virtual ~TComposeWin();
		//bool __fastcall CloseWindow(); // for closing by mainform
		void __fastcall LoadIni(bool winpos);
		//void __fastcall LoadProxyBox();
		bool __fastcall SendMessage();
		bool __fastcall SendNewsreaderPost();
		//void __fastcall WrapMessage(TStrings *message);
		void __fastcall OpenNewMessage();
		void __fastcall OpenMessage(const AnsiString &BoxName, const AnsiString &Key);
		bool __fastcall OpenQueueMessage(const AnsiString &Queue);
		void __fastcall OpenTemplate(const AnsiString &name);
		void __fastcall OpenDraft(const AnsiString &name);
		void __fastcall OpenDefMessage();
		void __fastcall MassageHeadersNewMessage(TStrings *msg);
		void __fastcall SetCaption(AnsiString MsgType, const AnsiString &MsgName);
		void __fastcall LoadEditor(const AnsiString &newmsg);
		void __fastcall LoadEditor(TStrings *newmsg);
		void __fastcall SetupToolbar(int mode);
		void __fastcall EnableButtons();
		//bool __fastcall MessageGoodToGoX(TStrings *Msg);
		bool __fastcall QueueMessage();
		int  __fastcall SetCursorPos();
		void __fastcall SetCaptionModified(bool mod);
		bool __fastcall CheckUpdateRemailerPages();
		void __fastcall ShowStatus(const AnsiString &text);
		void __fastcall CheckChangeDefaultKeyID();
		bool __fastcall CheckHandleNymMessage(TStrings *message);
		bool __fastcall CheckHandleNymMessageAfterDecrypt(TStrings *message);
		bool __fastcall CheckHandlePGP(TStrings *message);
		bool __fastcall HandleNymPGP(TStrings *message);
		bool __fastcall CheckHandleCurrentMessage();
		bool __fastcall CheckPeriodStartingAnyLine();
		bool __fastcall CheckHandleProblemQueue();
		bool __fastcall NymCfgCopyData(LPSTR Msg);
		void __fastcall ReplyCopyData(LPSTR msg);
#ifdef QS2
		bool __fastcall CheckHandleExistingMailError();
#endif
		//bool __fastcall CheckCreateDefMessage();
		void __fastcall SetExpertMode(bool mode);
		bool __fastcall HasHeader(const AnsiString &Header);
		void __fastcall PGPHeaderToButtons(const AnsiString &Header);
		void __fastcall PGPButtonsToHeader(TStrings *message);
		AnsiString __fastcall PGPButtonsToHeader();
		//void __fastcall SetModified(bool mod);
		//void __fastcall GoOriginal();
		bool __fastcall Modified();
		void __fastcall SaveTemplate(const AnsiString &name, bool warn=true);
		void __fastcall SaveDraft(const AnsiString &name);
		void __fastcall SaveDefMessage();
		void __fastcall SaveDefArticle();
		bool __fastcall SaveAsTemplate();
		bool __fastcall SaveAsDraft();
		bool __fastcall SaveAs();
		bool __fastcall Save();
		bool __fastcall IsPGP(TStrings *message);
		bool __fastcall HasFcc(TStrings *message);
		// message functions
		void virtual __fastcall WMShowStatus(TMessage& Msg);
		void virtual __fastcall WMIniChange(TMessage& Msg);
		void virtual __fastcall WMLoadProblem(TMessage& Msg);
		void virtual __fastcall WMLoadCancel(TMessage& Msg);
		void virtual __fastcall WMChangeDefKey(TMessage& Msg);
		void virtual __fastcall WMCloseWindow(TMessage& Msg);

		BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_SHOWSTATUS, TMessage, WMShowStatus)
		MESSAGE_HANDLER(WM_APPINICHANGE, TMessage, WMIniChange)
		MESSAGE_HANDLER(WM_LOADPROBLEM, TMessage, WMLoadProblem)
		MESSAGE_HANDLER(WM_LOADCANCEL, TMessage, WMLoadCancel)
		MESSAGE_HANDLER(WM_CHANGEDEFKEY, TMessage, WMChangeDefKey)
		MESSAGE_HANDLER(WM_CLOSEWINDOW, TMessage, WMCloseWindow)
		END_MESSAGE_MAP(TForm)
};

// close states for forced closing
//const int csOPEN        = 0;
//const int csCLOSING     = 1;
//const int csSTAYINGOPEN = 2;
//---------------------------------------------------------------------------
extern PACKAGE TComposeWin *ComposeWin;
extern TList *composewindows;
extern bool firstrun;
//---------------------------------------------------------------------------
#endif
