/*
*  eheadersdlgs.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef eheadersdlgsH
#define eheadersdlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <CheckLst.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------

bool __fastcall EditEmailHeaders(TForm *Owner);
void __fastcall LoadAcceptedHeaders(TStrings *hdrs);

class TEHeadersDlg : public TForm
{
__published:	// IDE-managed Components
        TButton *OkBtn;
        TButton *CancelBtn;
        TRichEdit *RichEdit1;
        TPopupMenu *PopupMenu;
        TMenuItem *PopupAdd;
        TMenuItem *PopupDelete;
        TListBox *HeaderList;
        TMenuItem *N1;
        TMenuItem *PopupResizedialog;
        TMenuItem *PopupLocksize;
        TMenuItem *N2;
        TMenuItem *PopupReset;
        TLabel *Label3;
	TButton *DeleteBtn;
	TButton *NewBtn;
        void __fastcall PopupResetClick(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall DeleteBtnClick(TObject *Sender);
        void __fastcall AddBtnClick(TObject *Sender);
        void __fastcall PopupMenuPopup(TObject *Sender);
        void __fastcall PopupResizedialogClick(TObject *Sender);
        void __fastcall PopupLocksizeClick(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall HeaderListDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
	void __fastcall HeaderListClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        bool saved;
        AnsiString orghdrs, orgvalid, orgwin;
        __fastcall TEHeadersDlg(TComponent* Owner);
        __fastcall virtual ~TEHeadersDlg();
};

//---------------------------------------------------------------------------
extern PACKAGE TEHeadersDlg *EHeadersDlg;
//---------------------------------------------------------------------------
#endif
