/*
*  inputdlgs.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef inputdlgsH
#define inputdlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------

AnsiString __fastcall GetUserInput(TForm *Owner, const AnsiString &DlgCaption,
   const AnsiString &Prompt, const AnsiString &Default = "",
   TStrings *Existing = NULL);

class TInputDlg : public TForm
{
__published:	// IDE-managed Components
        TEdit *Input;
        TLabel *Prompt;
        TButton *OkBtn;
        TButton *CancelBtn;
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall InputChange(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
private:	// User declarations
public:		// User declarations
		TStrings *existing;
		AnsiString orgText;
		__fastcall virtual TInputDlg(TComponent* Owner);
        __fastcall virtual TInputDlg(TComponent* Owner, TStrings *Existing);
};

//---------------------------------------------------------------------------
//extern PACKAGE TInputDlg *InputDlg;
//---------------------------------------------------------------------------
#endif
