/*
*  smtphostdlgs.cpp 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "licensedlgs.h"
#include "utility.h"
#include "global.h"
#include "qslver.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TLicenseDlg *LicenseDlg;
//---------------------------------------------------------------------------

void __fastcall ShowLicense(TForm *Owner)
{
   TLicenseDlg *licensedlg = new TLicenseDlg(Owner);
   licensedlg->ShowModal();
   delete licensedlg;
}
//---------------------------------------------------------------------------

__fastcall TLicenseDlg::TLicenseDlg(TComponent* Owner)
	: TForm(Owner)
{
   SetEditRect(RichEdit1);
   if (FileExists(AppLicense()))
	  RichEdit1->Lines->LoadFromFile(AppLicense());
   else
   {
	  RichEdit1->Lines->Text =
		 "Sorry to say, the license file, " + ExtractFileName(AppLicense()) + ", "
		 "is missing from my home \r\ndirectory. Reinstalling the program "
		 "should correct the problem.";
   }
   RichEdit1->Top = 1;
   RichEdit1->Left = RichEditIndent;
   RichEdit1->Height = Panel1->Height - 2;
   RichEdit1->Width = Panel1->Width - RichEditIndent;
   RichEdit1->Anchors = TAnchors() << akLeft << akTop << akRight << akBottom;
   RichEdit1->ParentColor = true;
   Caption = QuickSilverVersion();
   ActiveControl = OkBtn;
}
//---------------------------------------------------------------------------

void __fastcall TLicenseDlg::FormResize(TObject *Sender)
{
   SetEditRect(RichEdit1);
}
//---------------------------------------------------------------------------

void __fastcall TLicenseDlg::FormPaint(TObject *Sender)
{
   SetEditRect(RichEdit1);
}
//---------------------------------------------------------------------------
