/*
*  logdlgs.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef logdlgsH
#define logdlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------

void __fastcall ViewSMTPLog(TForm *Owner);
#ifdef QS2
void __fastcall ViewPOP3Log(TForm *Owner);
void __fastcall ViewNNTPLog(TForm *Owner);
#endif

class TLogDlg : public TForm
{
__published:	// IDE-managed Components
        TButton *CloseBtn;
        TPanel *Panel1;
        TRichEdit *Viewer;
        TPopupMenu *PopupMenu1;
        TMenuItem *Copy1;
        TMenuItem *N1;
        TMenuItem *Resizedialog1;
        TMenuItem *Locksize1;
        TCheckBox *ChainsBox;
        TMenuItem *Selectall1;
	TMenuItem *N2;
	TMenuItem *Clear1;
        void __fastcall Copy1Click(TObject *Sender);
        void __fastcall PopupMenu1Popup(TObject *Sender);
        void __fastcall Resizedialog1Click(TObject *Sender);
        void __fastcall Locksize1Click(TObject *Sender);
        void __fastcall ChainsBoxClick(TObject *Sender);
        void __fastcall Selectall1Click(TObject *Sender);
	void __fastcall Clear1Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        AnsiString orgwin;
        TStringList *log;
        __fastcall TLogDlg(TComponent* Owner);
        __fastcall virtual ~TLogDlg();
};

//---------------------------------------------------------------------------
//extern PACKAGE TLogDlg *LogDlg;
//---------------------------------------------------------------------------
#endif
