/*
*  openssl.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#ifndef opensslH
#define opensslH
//---------------------------------------------------------------------------
#include "overbyteicswsocket.hpp"

AnsiString __fastcall OpenSSLVersion();
void __fastcall CreateQSPem(TForm *Owner, const AnsiString &FileName);
bool __fastcall CheckCreateQSPem(TForm *Owner, TSslContext *SslContext);

char* __fastcall ssleay_version(int t);
typedef char*(*SSLEAY_VERSION)(int);

// constants for cipher suite replacement
const AnsiString SSLCipherSuites = "sslciphersuites";

const AnsiString HttpSSLCipherSuite = sslCiphersMozillaSrvHigh; // defined in OverbyteIcsWSocket.pas
//const AnsiString HttpSSLCipherSuite = "ALL:!ADH:!MD5:!SSLv3:+TLSv1.2:@STRENGTH";
//const AnsiString HttpSSLCipherSuite   = "ALL:!ADH:!MD5:!SSLv2:+TLSv1.2:@STRENGTH";

const AnsiString SmtpSSLCipherSuite = sslCiphersMozillaSrvHigh; // defined in OverbyteIcsWSocket.pas
//const AnsiString SmtpSSLCipherSuite = "ALL:!ADH:!MD5:!SSLv3:+TLSv1.2:@STRENGTH";
//const AnsiString SmtpSSLCipherSuite   = "ALL:!ADH:!MD5:!SSLv2:+TLSv1.2:@STRENGTH";

const AnsiString HttpSSLciphersuite = "http";
const AnsiString SmtpSSLciphersuite = "smtp";

//---------------------------------------------------------------------------
#endif
