/*
*  packdbdlgs.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef packdbdlgsH
#define packdbdlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "dbs.h"
//---------------------------------------------------------------------------

void __fastcall PackDatabase(TForm *Owner);

class TPackDBDlg : public TForm
{
__published:	// IDE-managed Components
        TButton *OkBtn;
        TButton *CancelBtn;
        TBevel *Bevel1;
        TLabel *info;
        TPanel *Panel1;
        TRichEdit *Log;
        void __fastcall OkBtnClick(TObject *Sender);
        void __fastcall CancelBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        bool cancel;
        int fails, itemfails;
        __fastcall TPackDBDlg(TComponent* Owner);
        void __fastcall LogLAST(const AnsiString &msg);
        void __fastcall LogADD(const AnsiString &msg);
        bool __fastcall PackItem(TDBindex *frIndex, TDBindex *toIndex,
           const AnsiString &key, int capfield = 0);
        void __fastcall DoPackItem(TDBindex *frIndex, TDBindex *toIndex,
           const AnsiString &key, int capfield = 0);
        void __fastcall PackIndex(TDBindex *frParent, TDBindex *toParent,
           const AnsiString &path, int capfield = 0);
        void __fastcall DoPackIndex(TDBindex *frParent, TDBindex *toParent,
           const AnsiString &path, int capfield = 0);
        void __fastcall PackDatabase();
};

//---------------------------------------------------------------------------
extern PACKAGE TPackDBDlg *PackDBDlg;
//---------------------------------------------------------------------------
#endif
