/*
*  proxydlgs2.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef proxydlgs2H
#define proxydlgs2H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------

bool __fastcall NewProxy(TForm *Owner, TStrings *Proxy, TStrings *Proxies);
bool __fastcall EditProxy(TForm *Owner, TStrings *Proxy, TStrings *Proxies);

class TProxyDlg2 : public TForm
{
__published:	// IDE-managed Components
        TCheckBox *Auth;
        TEdit *Password;
        TEdit *UserID;
        TCheckBox *HideBox;
        TLabel *Label6;
        TLabel *Label5;
        TCheckBox *TOR;
        TComboBox *Socks;
        TLabel *Label4;
        TEdit *Host;
        TLabel *Label2;
        TBevel *Bevel1;
        TEdit *Name;
        TLabel *Label1;
        TGroupBox *GroupBox1;
        TCheckBox *SMTPBox;
        TCheckBox *HTTPBox;
        TEdit *SMTPPort;
        TEdit *HTTPPort;
        TButton *OkBtn;
        TButton *CancelBtn;
        TButton *HelpBtn;
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall SMTPBoxClick(TObject *Sender);
        void __fastcall HTTPBoxClick(TObject *Sender);
        void __fastcall AuthClick(TObject *Sender);
        void __fastcall HideBoxClick(TObject *Sender);
        void __fastcall TORClick(TObject *Sender);
        void __fastcall HelpBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        bool newproxy;
        AnsiString orgname;
        TStrings *proxy, *proxies;
        __fastcall virtual TProxyDlg2(TComponent* Owner);
        __fastcall virtual TProxyDlg2(TComponent* Owner, TStrings *Proxy, TStrings *Proxies);
        __fastcall virtual~TProxyDlg2();
        AnsiString __fastcall GetNextDefaultName();
        bool __fastcall Modified();
};
//---------------------------------------------------------------------------
extern PACKAGE TProxyDlg2 *ProxyDlg2;
//---------------------------------------------------------------------------
#endif
