/*
*  licensedlgs.cpp 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "smtphostdlgs.h"
#include "smtphostdsadlgs.h"
#include "global.h"
#include "utility.h"
#include "qsdbs.h"
//#include "proxydlgs.h"
#include "proxymandlgs.h"
#include "msgmans.h"
#include "help.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//TSMTPHostDlg *SMTPHostDlg;
//---------------------------------------------------------------------------

bool __fastcall AddSMTPHost(TForm *Owner, TStrings *host, TStrings *existing)
{
   if (host->Values["port"].IsEmpty())
	  host->Values["port"] = "25";
   if (host->Values["tls"].IsEmpty())
	  host->Values["tls"] = "none";

   TSMTPHostDlg *hostdlg = new TSMTPHostDlg(Owner, host, existing);
   hostdlg->ShowModal();
   bool ok = hostdlg->ModalResult == mrOk;
   delete hostdlg;
   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall EditSMTPHost(TForm *Owner, TStrings *host, TStrings *existing)
{
   TSMTPHostDlg *hostdlg = new TSMTPHostDlg(Owner, host, existing);
   hostdlg->ShowModal();
   bool ok = hostdlg->ModalResult == mrOk;
   delete hostdlg;
   return ok;
}
//---------------------------------------------------------------------------

/*bool __fastcall ManageSingleSMTPServer(TForm *Owner, bool &reloadmessage)
{
   reloadmessage = false;
   TStringList *host = new TStringList();
   TStringList *existing = new TStringList();

   TStringList *message = new TStringList();
   TMsgManager *msg = new TMsgManager(message);
   DB->LoadDefMessage(message);
   AnsiString newserver, server = GetTok(0, msg->GetHeader("Host:"), ':');

   DB->LoadSMTP(server, host);
   if (!host->Count)
   {
	  host->Values["key"] = server;
	  host->Values["host"] = server;
   }

   TSMTPHostDlg *hostdlg = new TSMTPHostDlg(Owner, host, existing);
   hostdlg->Label6->Caption = "Your messages must contain a 'Host' header "
   "with the value from the SMTP Server field below.";
   hostdlg->SMTPKey->Enabled = false;
   hostdlg->SMTPKey->ParentColor = true;
   hostdlg->ProxyBtn->Visible = true;
   hostdlg->ShowModal();
   bool ok = hostdlg->ModalResult == mrOk;
   if (ok)
   {
	  newserver = host->Values["host"];
	  host->Values["key"] = newserver;
	  DB->DelSMTP(server);
	  DB->SaveSMTP(newserver, host);
	  if (newserver != server)
	  {
		 int x = msg->DelHeader("Host:");
		 assert(x >= 0);
		 message->Insert(x, "Host: " + newserver);
		 DB->SaveDefMessage(message);
		 reloadmessage = true;
	  }
   }
   delete hostdlg;

   delete msg;
   delete message;

   delete existing;
   delete host;

   return ok;
}*/
//---------------------------------------------------------------------------

__fastcall TSMTPHostDlg::TSMTPHostDlg(TComponent* Owner)
		: TForm(Owner)
{
}
//---------------------------------------------------------------------------

__fastcall TSMTPHostDlg::TSMTPHostDlg(TComponent* Owner, TStrings *Hostdata,
   TStrings *Existing) : TForm(Owner)
{
   PopupParent = (TForm*)Owner;
   TIniFile *ini = new TIniFile(AppIni());
   AssignFont(Font, ini->ReadString("settings", "dialogfont", OptsDefDialogFont));
   AssignFont(SMTPKey->Font, ini->ReadString("settings", "windowfont",
	  OptsDefWindowFont));
   SMTPServer->Font->Assign(SMTPKey->Font);
   SMTPPort->Font->Assign(SMTPKey->Font);
   SMTPUserID->Font->Assign(SMTPKey->Font);
   SMTPPassword->Font->Assign(SMTPKey->Font);
#ifdef QS2
   expertmode = ini->ReadBool("settings", "expertmode", false);
#else
   expertmode = true;
#endif
   ProxyBtn->Caption = expertmode ? "&Proxies" : "&Proxy";
   delete ini;

   hostdata = Hostdata;
   existing = Existing;
   SMTPKey->Text = hostdata->Values["key"];
   SMTPServer->Text = hostdata->Values["host"];
   SMTPPort->Text = hostdata->Values["port"];
   SMTPAuth->Checked = hostdata->Values["auth"] == "1";
   SMTPUserID->Text = hostdata->Values["userid"];
   SMTPPassword->Text = hostdata->Values["password"];
   SMTPTls->ItemIndex = SMTPTls->Items->IndexOf(hostdata->Values["tls"]);
   if ((SMTPTls->ItemIndex < 0))
	  SMTPTls->ItemIndex = 0;

   SMTPAuthClick(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TSMTPHostDlg::FormCloseQuery(TObject *Sender,
	  bool &CanClose)
{
   bool mod = Modified();
   if (mod)
   {
	  if (ModalResult == mrCancel)
	  {
		 switch (MsgBox(this,
		   "Your host info is modified. Save your changes? ",
			MT_CONFIRM, MB_YESNOCANCEL))
		 {
			case IDCANCEL:
			   CanClose = false;
			case IDNO:
			   return;
		 }
		 ModalResult = mrOk;
	  }

	  if (SMTPServer->Text.Pos(":") > 0)
	  {
		 MsgBox(this,
			"Sorry, colons ':' not allowed in Name and Server fields.   ",
			MT_INFO, MB_OK);
		 ActiveControl = SMTPServer;
		 CanClose = false;
		 return;
	  }
	  if (SMTPKey->Text.Pos(":") > 0)
	  {
		 MsgBox(this,
			"Sorry, colons ':' not allowed in Name and Server fields.   ",
			MT_INFO, MB_OK);
		 ActiveControl = SMTPKey;
		 CanClose = false;
		 return;
	  }

	  if (SMTPKey->Text.IsEmpty() && !SMTPServer->Text.IsEmpty())
		 SMTPKey->Text = SMTPServer->Text;

	  if (SMTPPort->Text.IsEmpty())
	  {
		 SMTPPort->Text = "25";
		 SMTPTls->ItemIndex = 0;

	  }

	  if ((SMTPPort->Text == "587" || SMTPPort->Text == "submission") &&
		   SMTPTls->Text != "TLS")
	  {
		 if (MsgBox(this,
			"You have set the SMTP port to 587 but TLS/SSL is not set to TLS.  \n"
			"This probably won't work. Shall I change it to TLS?",
			MT_CONFIRM, MB_YESNO) == IDYES)
		 {
			SMTPTls->ItemIndex = 1;
		 }
		 else
		 {
			MsgBox(this,
			   "Ok, but if the connection doesn't work, this is the first   \n"
			   "thing you need to look at.",
			   MT_INFO, MB_OK);
		 }
	  }

	  if ((SMTPPort->Text == "465" || SMTPPort->Text == "smtps") &&
		   SMTPTls->Text != "SSL")
	  {
		 if (MsgBox(this,
			"You have set the SMTP port to 465 but TLS/SSL is not set to SSL.  \n"
			"This probably won't work. Shall I change it to SSL?",
			MT_CONFIRM, MB_YESNO) == IDYES)
		 {
			SMTPTls->ItemIndex = 2;
		 }
		 else
		 {
			MsgBox(this,
			   "Ok, but if the connection doesn't work, this is the first   \n"
			   "thing you need to look at.",
			   MT_INFO, MB_OK);
		 }
	  }

	  if ((SMTPPort->Text == "25" || SMTPPort->Text == "smtp") &&
		   SMTPTls->Text != "none")
	  {
		 if (MsgBox(this,
			"You have set the SMTP port to 25 but TLS/SSL is not set to 'none'.  \n"
			"This probably won't work. Shall I change it to none?",
			MT_CONFIRM, MB_YESNO) == IDYES)
		 {
			SMTPTls->ItemIndex = 0;
		 }
		 else
		 {
			MsgBox(this,
			   "Ok, but if the connection doesn't work, this is the first   \n"
			   "thing you need to look at.",
			   MT_INFO, MB_OK);
		 }
	  }

	  if (SMTPServer->Text.IsEmpty())
	  {
		 MsgBox(this,
			"Problem! You have to provide an SMTP server to accept your \n"
			"outgoing mail. If you're not sure what it is, check your regular \n"
			"email program.",
			 MT_INFO, MB_OK);
		 CanClose = false;
		 return;
	  }

	  if (SMTPAuth->Checked &&
		 (SMTPUserID->Text.IsEmpty() || SMTPPassword->Text.IsEmpty()))
	  {
		 MsgBox(this,
			"Problem! You have SMTP Authentication enabled. That also \n"
			"requires you provide User ID and Password.",
			 MT_INFO, MB_OK);
		 CanClose = false;
		 return;
	  }

	  if (existing->IndexOf(SMTPKey->Text) >= 0)
	  {
		 MsgBox(this,
			"Sorry, your 'Name' value already exists! It must be unique!   ",
			MT_INFO, MB_OK);
		 CanClose = false;
		 return;
	  }

	  hostdata->Values["key"] = SMTPKey->Text;
	  hostdata->Values["host"] = SMTPServer->Text;
	  hostdata->Values["port"] = SMTPPort->Text;
	  hostdata->Values["auth"] = SMTPAuth->Checked ? "1" : "0";
	  hostdata->Values["userid"] = SMTPUserID->Text;
	  hostdata->Values["password"] = SMTPPassword->Text;
	  hostdata->Values["tls"] = SMTPTls->Text;

	  ShowSMTPNameAlert(this, SMTPKey->Text);
   }

   if (!mod && ModalResult == mrOk)
	  ModalResult = mrCancel;
}
//---------------------------------------------------------------------------

bool __fastcall TSMTPHostDlg::Modified()
{
   return SMTPKey->Text != hostdata->Values["key"] ||
   SMTPServer->Text != hostdata->Values["host"] ||
   SMTPPort->Text != hostdata->Values["port"] ||
   SMTPAuth->Checked != (hostdata->Values["auth"] == "1") ||
   SMTPUserID->Text != hostdata->Values["userid"] ||
   SMTPPassword->Text != hostdata->Values["password"] ||
   SMTPTls->Text != hostdata->Values["tls"];
}
//---------------------------------------------------------------------------

void __fastcall TSMTPHostDlg::SMTPAuthClick(TObject *Sender)
{
   if (SMTPAuth->Checked)
   {
	  SMTPUserID->Enabled = true;
	  SMTPUserID->Color = clWindow;
	  SMTPPassword->Enabled = true;
	  SMTPPassword->Color = clWindow;
	  HideBox->Enabled = true;
	  Label2->Enabled = true;
	  Label5->Enabled = true;
   }
   else
   {
	  SMTPUserID->Enabled = false;
	  SMTPUserID->ParentColor = true;
	  SMTPPassword->Enabled = false;
	  SMTPPassword->ParentColor = true;
	  HideBox->Enabled = false;
	  HideBox->Checked = true;
	  Label2->Enabled = false;
	  Label5->Enabled = false;
   }
}
//---------------------------------------------------------------------------

void __fastcall TSMTPHostDlg::SMTPServerExit(TObject *Sender)
{
   if (SMTPKey->Text.IsEmpty())
	  SMTPKey->Text = SMTPServer->Text;
}
//---------------------------------------------------------------------------

void __fastcall TSMTPHostDlg::ProxyBtnClick(TObject *Sender)
{
   //if (expertmode)
   ManageProxies(this);
   //else
   //	  EditSMTPProxy(this);
}
//---------------------------------------------------------------------------

void __fastcall TSMTPHostDlg::HelpBtnClick(TObject *Sender)
{
   DisplayHtmlHelpTopic(this, "::/html/smtphost.htm>smtphosts");
}
//---------------------------------------------------------------------------

void __fastcall TSMTPHostDlg::HideBoxClick(TObject *Sender)
{
  if (!HideBox->Checked)
  {
	SMTPPassword->PasswordChar = '\0';
  }
  else
  {
	SMTPPassword->PasswordChar = '*';
  }
}
//---------------------------------------------------------------------------

void __fastcall TSMTPHostDlg::SMTPPortExit(TObject *Sender)
{
   if (SMTPPort->Text == "587" || SMTPPort->Text == "submission") {
	  SMTPTls->ItemIndex = 1;
   }
   if (SMTPPort->Text == "465" || SMTPPort->Text == "smtps") {
	  SMTPTls->ItemIndex = 2;
   }
}
//---------------------------------------------------------------------------

void __fastcall TSMTPHostDlg::SMTPPortChange(TObject *Sender)
{
   if (SMTPPort->Text == "587" || SMTPPort->Text == "submission")
       SMTPTls->ItemIndex = 1;
   else
   if (SMTPPort->Text == "465" || SMTPPort->Text == "smtps")
       SMTPTls->ItemIndex = 2;
   else
       SMTPTls->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TSMTPHostDlg::SMTPServerChange(TObject *Sender)
{
   if (!SMTPKey->Enabled)
      SMTPKey->Text = SMTPServer->Text;        
}
//---------------------------------------------------------------------------

