/*
*  templatedlgs.h 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef templatedlgsH
#define templatedlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------

AnsiString __fastcall SaveTemplateAs(TForm *Owner, AnsiString CurrName);
AnsiString __fastcall SelectTemplateFollowup(TForm *Owner);
AnsiString __fastcall SelectTemplateReply(TForm *Owner);
AnsiString __fastcall SelectTemplate(TForm *Owner);

class TTemplateDlg : public TForm
{
__published:	// IDE-managed Components
        TLabel *Label1;
        TButton *OkBtn;
        TButton *CancelBtn;
        TListBox *TempList;
        TEdit *SaveName;
        TLabel *Label2;
        TPopupMenu *PopupMenu1;
        TMenuItem *Delete1;
        TMenuItem *N1;
        TMenuItem *Resizedialog1;
        TMenuItem *Locksize1;
        TButton *Help;
        TButton *DeleteBtn;
        TButton *RenameBtn;
        TMenuItem *Rename1;
        void __fastcall Open1Click(TObject *Sender);
        void __fastcall TempListClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall Delete1Click(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall PopupMenu1Popup(TObject *Sender);
        void __fastcall Resizedialog1Click(TObject *Sender);
        void __fastcall Locksize1Click(TObject *Sender);
        void __fastcall TempListDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall HelpClick(TObject *Sender);
        void __fastcall Rename1Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        AnsiString orgwin;
        __fastcall TTemplateDlg(TComponent* Owner);
        __fastcall virtual ~TTemplateDlg();
};

//---------------------------------------------------------------------------
//extern PACKAGE TTemplateDlg *TemplateDlg;
//---------------------------------------------------------------------------
#endif
